import RPi.GPIO as GPIO
import time

class Poubelle:
  def __init__(self, _couleur, _GPIO):
    self.couleur = _couleur
    self.GPIO = _GPIO

    # Use pin self.GPIO for PWM signal
    GPIO.setup(self.GPIO, GPIO.OUT)

    self.pwm = GPIO.PWM(self.GPIO, 50)

  def ouvrir(self):
    # Init at 0°
    self.pwm.start(3)  # 90 degre -> 1,6ms sur 20 ms
    time.sleep(1)
    #print(self.angle_to_percent(0))

    # Go at 90°
    self.pwm.ChangeDutyCycle(self.angle_to_percent(90))
    time.sleep(3)

    # Finish at 180°
    self.pwm.ChangeDutyCycle(3)
    time.sleep(1)

    # Close GPIO & cleanup
    #self.pwm.stop()
    #GPIO.cleanup()

  def stop(self):
    self.pwm.stop()
    

  # Set function to calculate percent from angle
  def angle_to_percent(self,angle):
    if angle > 180 or angle < 0:
        return False

    start = 4
    end = 12.5
    ratio = (end - start) / 180  # Calcul ratio from angle to percent

    angle_as_percent = angle * ratio

    return start + angle_as_percent


















